#include<iostream>
#include<time.h>

using namespace std;

void fillWithRandomValues(int list[], int size, int min, int max)
{
	for (int i = 0; i < size; i++)
	{
		if (min <= max)
		{
			list[i] = rand() % (max - min + 1) + min;
		}
		else
		{
			list[i] = 0;
		}
	}
}

int countOfOdds(int list[], int size)
{
	int result = 0;

	for (int i = 0; i < size; i++)
	{
		if (list[i]%2 != 0)
		{
			result++;
		}
	}

	return result;
}

int countOfEvens(int list[], int size)
{
	return size - countOfOdds(list, size);
}


void displayList(int list[], int size, char delimiter = '\n')
{
	//for (int i = size-1; i >= 0; i--)
	for (int i = 0; i < size; i++)
	{
		cout << list[i];
		if (i < size - 1)
		{
			cout << delimiter;
		}
	}
}

bool isSorted(int list[], int size)
{
	bool result = true;

	for (int i = 0; i < size - 1; i++)
	{
		if (list[i] > list[i + 1])
		{
			result = false;
		}
	}


	return result;
}

void randomSort(int list[], int size)
{
	int comparisons = 0;

	while(!isSorted(list,size))
	{
		int i = rand() % size;
		int j = rand() % size;
		int temp = list[j];
		list[j] = list[i];
		list[i] = temp;
		comparisons++;
	}
	cout << comparisons << endl;
}

void selectionSort(int list[], int size)
{
	for (int i = 0; i < size-1; i++)
	{
		int indexOfSmallest = i;
		//find the smallest and store its index
		for (int j = i;j < size; j++)
		{
			if (list[j] > list[indexOfSmallest])
			{
				indexOfSmallest = j;
			}
		}

		//swap the smallest with index i
		int temp = list[i];
		list[i] = list[indexOfSmallest];
		list[indexOfSmallest] = temp;
	}
}
void bubbleSort(int list[], int size)
{
	int comparisons = 0;
	bool swapNeeded = true;
	for (int i = 0; i < size - 1 && swapNeeded; i++)
	{
		swapNeeded = false;
		for (int j = 0; j < size - 1 - i; j++)
		{
			comparisons++;
			if (list[j] > list[j + 1])
			{
				swapNeeded = true;
				int temp = list[j];
				list[j] = list[j + 1];
				list[j + 1] = temp;
			}
		}
	}
	cout << comparisons << endl;
}

// Big O notation - CS measurement of algorithm efficiency
// Big O of Bubble and Selection sort is n^2
void main()
{
	srand((unsigned int)time(NULL));
	int list[100];
	int list2[20];
	fillWithRandomValues(list, 100, 1, 100);
	randomSort(list, 100);
	displayList(list, 100, ',');


}
